#pragma once

#include <UIMLView.h>

#include "NetworkAPIProcessor.h"

class EquipmentElement : public Framework::UIMLElement
{
public:
    EquipmentElement();
    //! prüft, ob dieses UIML Element für ein bestimmtes xml Element zuständig
    //! ist
    bool isApplicableFor(Framework::XML::Element& element) override;
    //! erstellt eine neue Zeichnung zu einem gegebenen xml Element
    Framework::Zeichnung* parseElement(Framework::XML::Element& element,
        Framework::UIMLContainer& generalFactory) override;
    //! wendet die layout parameter zu einer Zeichnung an
    void layout(Framework::XML::Element& element,
        Framework::Zeichnung& z,
        int pWidth,
        int pHeight,
        Framework::UIMLContainer& generalLayouter) override;
};

class EquipmentView : public Framework::ZeichnungHintergrund,
                      public NetworkAPIProcessor
{
private:
    int entityId;

public:
    EquipmentView(int entityId);
    void api(char* message) override;
    bool tick(double tickVal) override;
    void render(Framework::Bild& rObj) override;
    void doMausEreignis(Framework::MausEreignis& me, bool userRet) override;
};